
/*** Generated through Lumonix shaderFX  by: till 'rollin' maginot _ till.maginot.eu _ 06.2010   ***/ 

/*** Normalmap Toon/Comic Shader v0.58 ***/

// This FX shader was built to support 3ds Max's DXSAS shader compiler. 
string ParamID = "0x000001";	// this string tells 3ds Max to use the DXSAS compiler 
 



/*============================================================================
 ============= one_Light TECHNIQUE ============= 
============================================================================*/





bool useDiffuseMap
<
	string UIName = "+   UseDiffuseMap";
> = false;
 
texture diffuseMap : DiffuseMap
<
	string ResourceName = "D_tak.tga";
	string UIName = "DiffuseMap";
	string ResourceType = "2D";
>;
 
sampler2D diffuseMapSampler = sampler_state
{
	Texture = <diffuseMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
float3 diffuseColour
<
	string UIName = "  DiffuseColour";
	string UIWidget = "Color";
> = {0.501961f, 0.501961f, 0.501961f };
 
float diffuseToAmbient
<
	string UIWidget = "Spinner";
	float UIMin = -1.0;
	float UIMax = 1.0;
	float UIStep = 0.05;
	string UIName = "  DiffuseToAmbient";
> = 0.0;
 
bool disableShading
<
	string UIName = "+   Disable_Shading";
> = false;
 









bool useVertexColours
<
	string UIName = "+   UseVertexColours";
> = false;
 
//Vertex Color and Alpha in from Max 
int texcoord0 : Texcoord 
<
	int Texcoord = 0;
	int MapChannel = 1;
	string UIWidget = "None"; 
>;

int texcoord1 : Texcoord 
<
	int Texcoord = 1;
	int MapChannel = 2;
	string UIWidget = "None"; 
>;

int texcoord2 : Texcoord 
<
	int Texcoord = 2;
	int MapChannel = 3;
	string UIWidget = "None"; 
>;

int texcoord3 : Texcoord 
<
	int Texcoord = 3;
	int MapChannel = 0;
	string UIWidget = "None"; 
>;

int texcoord4 : Texcoord 
<
	int Texcoord = 4;
	int MapChannel = -2;
	string UIWidget = "None"; 
>;








bool useRampedShading
<
	string UIName = "+   UseRampedShading";
> = false;
 
texture rampTexture
<
	string ResourceName = "ramp_hard1.jpg";
	string UIName = "RampTexture";
	string ResourceType = "2D";
>;
 
sampler2D rampTextureSampler = sampler_state
{
	Texture = <rampTexture>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
 
float rampContrast
<
	string UIWidget = "Spinner";
	float UIMin = -100.0;
	float UIMax = 100.0;
	float UIStep = 1.0;
	string UIName = "  RampContrast";
> = 3.0;

float rampRange
<
	string UIWidget = "Spinner";
	float UIMin = -999.0;
	float UIMax = 999.0;
	float UIStep = 0.1;
	string UIName = "  Ramp_Range";
> = 2.0;




bool useNormalmap
<
	string UIName = "+   UseNormalmap";
> = false;
 
texture NormalMap : NormalMap
<
	string ResourceName = "N_tak.tga";
	string UIName = "NormalMap";
	string ResourceType = "2D";
>;
 
sampler2D NormalMapSampler = sampler_state
{
	Texture = <NormalMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
 bool invertRed
<
	string UIName = "  Invert_Red";
> = false;

bool invertGreen
<
	string UIName = "  Invert_Green";
> = false;
 
float nmDepth
<
	string UIWidget = "Spinner";
	float UIMin = -100.0;
	float UIMax = 100.0;
	float UIStep = 0.1;
	string UIName = "NM_depth";
> = 1.0;







bool useSpecMap
<
	string UIName = "+   UseSpecMap";
> = false;
  

 
texture specMap : SpecularMap
<
	string ResourceName = "S_tak.tga";
	string UIName = "Spec Map ";
	string ResourceType = "2D";
>;
 
sampler2D specMapSampler = sampler_state
{
	Texture = <specMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
 float specOverlay
<
	string UIWidget = "Spinner";
	float UIMin = 0.0;
	float UIMax = 10.0;
	float UIStep = 0.01;
	string UIName = "  Spec_Overlay(additive)";
> = 0.0;
 
 float specBoost
<
	string UIWidget = "Spinner";
	float UIMin = 0.0;
	float UIMax = 999.0;
	float UIStep = 0.1;
	string UIName = "  SpecBoost";
> = 0.0;
 
 float specLevel
<
	string UIWidget = "Spinner";
	float UIMin = -200.0;
	float UIMax = 200.0;
	float UIStep = 0.1;
	string UIName = "  SpecLevel";
> = 2.0;
 
 
 
 
bool useGlossMap
<
	string UIName = "+   UseGlossMap";
> = false;
 
texture glossMap
<
	string ResourceName = "Gloss_tak.tga";
	string UIName = "GlossMap";
	string ResourceType = "2D";
>;
 
sampler2D glossMapSampler = sampler_state
{
	Texture = <glossMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
float glossBoost
<
	string UIWidget = "Spinner";
	float UIMin = 0.0;
	float UIMax = 999.0;
	float UIStep = 0.1;
	string UIName = "  GlossBoost";
> = 0.0;
 
float glossLevel
<
	string UIWidget = "Spinner";
	float UIMin = 0.0;
	float UIMax = 500.0;
	float UIStep = 0.1;
	string UIName = "  GlossLevel";
> = 1.0;
 

 
 
 
 
 

 
 

 
 
 
 
 
 
float4x4 worldIT : WorldInverseTranspose < string UIWidget = "None"; >;  
float4x4 ViewIXf : ViewInverse <string UIWidget="None";>;

bool useLitSphere
<
	string UIName = "+   UseLitSphere";
> = false;

texture LitSphere
<
	string ResourceName = "test.jpg";
	string UIName = "LitSphere";
	string ResourceType = "2D";
>;
 
sampler2D LitSphereSampler = sampler_state
{
	Texture = <LitSphere>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
float litSphereStrength
<
	string UIWidget = "Spinner";
	float UIMin = -999.0;
	float UIMax = 999.0;
	float UIStep = 0.1;
	string UIName = "   LitSphere_Strength";
> = 1.0;
 

 
 
 
 
 
 
 
 
 
 
 
 
 bool useRimlight
<
	string UIName = "+   UseRimlight";
> = false;
 
float rimRange
<
	string UIWidget = "Spinner";
	float UIMin = 0.0;
	float UIMax = 2.0;
	float UIStep = 0.1;
	string UIName = "  Rim_range";
> = 0.2;
 
 float rimContrast
<
	string UIWidget = "Spinner";
	float UIMin = -999.0;
	float UIMax = 999.0;
	float UIStep = 0.1;
	string UIName = "  Rim_contrast";
> = 2.0;

bool UIBool_rim_offsv
<
	string UIName = "  disable offs vector";
> = true;
 
float rimOffsX
<
	string UIWidget = "Spinner";
	float UIMin = -1.0;
	float UIMax = 1.0;
	float UIStep = 0.1;
	string UIName = "  rimL_offs_x";
> = 0.0;
 
float rimOffsY
<
	string UIWidget = "Spinner";
	float UIMin = -1.0;
	float UIMax = 1.0;
	float UIStep = 0.1;
	string UIName = "  rimL_offs_y";
> = 0.0;
 
float rimOffsZ
<
	string UIWidget = "Spinner";
	float UIMin = -1.0;
	float UIMax = 1.0;
	float UIStep = 0.1;
	string UIName = "  rimL_offs_z";
> = 0.0;
 
float4x4 viewInv : ViewInverse < string UIWidget = "None"; >;  
bool disableNMforRim
<
	string UIName = "   DisableNMforRimL";
> = false;
 
 
float3 rimColour
<
	string UIName = "  RimColour";
	string UIWidget = "Color";
> = {0.835294f, 0.952941f, 1.0f };
 

 
 
 
 
 
 
float cubeMapStrength
<
	string UIWidget = "Spinner";
	float UIMin = -999.0;
	float UIMax = 999.0;
	float UIStep = 0.1;
	string UIName = "  CubeMapStrength";
> = 1.0;
 
float4x4 world : World < string UIWidget = "None"; >;  
texture cubeMap : environment
<
	string ResourceName = "sunol_cubemap.dds";
	string UIName = "Cube Map";
	string ResourceType = "Cube";
>;
 
samplerCUBE cubeMapSampler = sampler_state
{
	Texture = <cubeMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
 
texture cubeMapMask
<
	string ResourceName = "tmp_flat_black.jpg";
	string UIName = "CubeMapMask";
	string ResourceType = "2D";
>;
 
sampler2D cubeMapMaskSampler = sampler_state
{
	Texture = <cubeMapMask>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
bool useCubeMap
<
	string UIName = "+   UseCubeMap";
> = false;
 
 
 
 
 








 
 
 
 
 

 
 
 

 
 
 
bool useSSS
<
	string UIName = "use sss";
> = false;
 
bool useSSSmask
<
	string UIName = "use sss mask";
> = false;
 
texture sssMask
<
	string ResourceName = "";
	string UIName = "sss mask";
	string ResourceType = "2D";
>;
 
sampler2D sssMaskSampler = sampler_state
{
	Texture = <sssMask>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
float sssRange
<
	string UIWidget = "Spinner";
	float UIMin = -999.0;
	float UIMax = 999.0;
	float UIStep = 0.1;
	string UIName = "sss_range";
> = 1.0;
 
float sssContrast
<
	string UIWidget = "Spinner";
	float UIMin = -999.0;
	float UIMax = 999.0;
	float UIStep = 0.1;
	string UIName = "sss_contrast";
> = 1.0;
 
float3 sssColor
<
	string UIName = "sss Color";
	string UIWidget = "Color";
> = {0.85098f, 0.156863f, 0.0117647f };
 
 
 
 
 
 
 
 
 
 
 
 
 
 
bool useOpacityMap
<
	string UIName = "+   UseOpacityMap";
> = false;
 
texture opacityMap
<
	string ResourceName = "darFly_body_A_01_test.tga";
	string UIName = "OpacityMap_(alphaChannel)";
	string ResourceType = "2D";
>;
 
sampler2D opacityMapSampler = sampler_state
{
	Texture = <opacityMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
float opacityValue
<
	string UIWidget = "Spinner";
	float UIMin = 0.0;
	float UIMax = 1.0;
	float UIStep = 0.1;
	string UIName = "  Opacity";
> = 1.0;
 
 
 
 
 
 
 
 
 
 bool useSelfilum
<
	string UIName = "+   UseSelf_illumination";
> = false;
 
texture selfiluminationMap
<
	string ResourceName = "tmp_flat_black.jpg";
	string UIName = "Self_illuminationMap";
	string ResourceType = "2D";
>;
 
sampler2D selfiluminationMapSampler = sampler_state
{
	Texture = <selfiluminationMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
 
 
 
 
 
 
 
 bool useLightAttenuation
<
	string UIName = "+   useLightAttenuation";
> = false;
 
float Attenuation3
<
	string UIWidget = "Spinner";
	float UIMin = 0.0;
	float UIMax = 10000.0;
	float UIStep = 0.1;
	string UIName = "Attenuation3";
> = 0.0;
 
float Attenuation2
<
	string UIWidget = "Spinner";
	float UIMin = 0.0;
	float UIMax = 10000.0;
	float UIStep = 0.1;
	string UIName = "Attenuation2";
> = 1.0;
 
float Attenuation1
<
	string UIWidget = "Spinner";
	float UIMin = 0.0;
	float UIMax = 10000.0;
	float UIStep = 0.1;
	string UIName = "Attenuation1";
> = 0.0;
 
float AttenuationScale
<
	string UIWidget = "Spinner";
	float UIMin = 0.0;
	float UIMax = 10000.0;
	float UIStep = 1.0;
	string UIName = "Attenuation Scale";
> = 1200.0;
 
 
 
 
 
 
 
 
 
float lightBoost
<
	string UIWidget = "Spinner";
	float UIMin = 0.0;
	float UIMax = 1.0;
	float UIStep = 0.01;
	string UIName = "  Light_Boost";
> = 1.0;
 
 
 
 
 
 
 
 
 
 
// this function does the different types of light attenuation 
float attenuation_funcT1(int lightattenType, float4 lightAttenuation, float3 lightVec) 
{ 
	float att = 1.0; 
	return att; 
} 
	 
// this function does the different types of cone angle 
float coneangle_funcT1(int lightconeType, float lightHotspot, float lightFalloff, float3 lightVec, float3 lightDir) 
{ 
	float cone = 1.0; 
	return cone; 
} 





















/************** light info **************/ 

float3 light1Dir : Direction 
< 
	string UIName = "Light 1 Direction"; 
	string Object = "TargetLight"; 
	string Space = "World"; 
		int refID = 1; 
> = {100.0f, 100.0f, 100.0f}; 

float3 light1Pos : POSITION 
< 
	string UIName = "Light 1 Position"; 
	string Object = "PointLight"; 
	string Space = "World"; 
		int refID = 1; 
> = {100.0f, 100.0f, 100.0f}; 

float4 light1Color : LIGHTCOLOR <int LightRef = 1; string UIWidget = "None"; > = { 1.0f, 1.0f, 1.0f, 1.0f}; 
float4 light1Attenuation : Attenuation <int LightRef = 1; string UIWidget = "None"; > = {20.0f, 30.0f, 0.0f, 100.0f}; 
float light1Hotspot : HotSpot <int LightRef = 1; string UIWidget = "None"; > = { 43.0f }; 
float light1Falloff : FallOff <int LightRef = 1; string UIWidget = "None"; > = { 45.0f }; 

#define light1Type 1
#define light1attenType 0
#define light1coneType 0
#define light1CastShadows false

//---------------------------------- 


float4x4 wvp : WorldViewProjection < string UIWidget = "None"; >;  
float4x4 worldI : WorldInverse < string UIWidget = "None"; >;  
// create the light vector 
float3 lightVec_funcT1(float3 worldSpacePos, float3 lightVector, float3x3 objTangentXf, int lightType) 
{ 
	float3 lightVec = mul(objTangentXf, (mul((lightVector - worldSpacePos), worldI).xyz)); 
	return lightVec; 
} 

// input from application 
	struct a2vT1 { 
	float4 position		: POSITION; 

	float2 texCoord		: TEXCOORD0; 
	float4 tangent		: TANGENT; 
	float4 binormal		: BINORMAL; 
	float4 normal		: NORMAL; 
	float3 vertcol		: TEXCOORD3; 
	float vertalpha 	: TEXCOORD4; 

}; 

// output to fragment program 
struct v2fT1 { 
        float4 position    		: POSITION; 

	float2 texCoord			: TEXCOORD0; 
        float3 worldTangent  	: TEXCOORD1; 
        float3 worldBinormal 	: TEXCOORD2; 
        float3 worldNormal   	: TEXCOORD3; 
        float3 eyeVec	    	: TEXCOORD4; 
        float3 viewDir	    	: TEXCOORD5; 
        float4 color    		: COLOR0; 
        float3 lightVec    		: TEXCOORD6; 

}; 

// Ambient Pass Vertex Shader: 
v2fT1 avT1(a2vT1 In, uniform float3 lightPos, uniform int lightType, uniform float3 lightDir) 
{ 
	v2fT1 Out = (v2fT1)0; 
	Out.position = mul(In.position, wvp);				//transform vert position to homogeneous clip space 

	In.texCoord += float2(0.0,1.0);		//this fixes Max's V texcoord which is off by one 
	Out.texCoord = In.texCoord;						//pass through texture coordinates from channel 1 
	//this code was added by the World Space Transform Node 
	Out.worldNormal = mul(In.normal, worldIT).xyz;		//compute world space normal 
	Out.worldBinormal = mul(In.binormal, worldIT).xyz;	//compute world space binormal 
	Out.worldTangent = mul(In.tangent, worldIT).xyz;		//compute world space tangent 
	//this code was added by the Eye Vector Node 
	float3x3 objTangentXf;								//build object to tangent space transform matrix 
	#ifdef YUP 
	objTangentXf[0] = In.tangent.xyz; 
	objTangentXf[1] = -In.binormal.xyz; 
	#else 
	objTangentXf[0] = In.binormal.xyz; 
	objTangentXf[1] = -In.tangent.xyz; 
	#endif 
	objTangentXf[2] = In.normal.xyz; 
	//these three lines were added by the Eye Vector Node 
	float4 osIPos = mul(viewInv[3], worldI);			//put world space eye position in object space 
	float3 osIVec = osIPos.xyz - In.position.xyz;		//object space eye vector 
	Out.eyeVec = mul(objTangentXf, osIVec);				//tangent space eye vector passed out 
	//this code was added by the World Space Transform Node 
	Out.viewDir = mul(In.position, world) - viewInv[3]; 
	//this code was added by the Vertex Color Node 
	Out.color = float4(In.vertcol.rgb, In.vertalpha.r); 


	return Out; 
} 

// Ambient Pass Pixel Shader: 
float4 afT1(v2fT1 In, uniform float3 lightDir, uniform float4 lightColor, uniform float4 lightAttenuation, uniform float lightHotspot, uniform float lightFalloff, uniform int lightType, uniform int lightattenType, uniform int lightconeType, uniform bool lightCastShadows, uniform int shadowPassCount) : COLOR 
{ 

	float4 selfiluminationMap = tex2D(selfiluminationMapSampler, In.texCoord.xy);
	float3 MathOperator_6421 = useSelfilum * selfiluminationMap.rgb;
	float uiConst_nm_1 = 1.0; 
	float uiConst_nm_0 = 0.0; 
	float4 NormalMap = tex2D(NormalMapSampler, In.texCoord.xy);
	NormalMap.xyz = NormalMap.xyz * 2 - 1;		//expand to -1 to 1 range 
	NormalMap.rgb = normalize(NormalMap.rgb); 		//normalized the normal vector 
	float MathIf_586;
	if (invertRed == uiConst_nm_1) MathIf_586 = (uiConst_nm_0 - NormalMap.r); else MathIf_586 = NormalMap.r; 
	float MathIf_7612;
	if (invertGreen == uiConst_nm_1) MathIf_7612 = (uiConst_nm_0 - NormalMap.g); else MathIf_7612 = NormalMap.g; 
	float3 MathVecConstuct_4834 = float3(MathIf_586, MathIf_7612, NormalMap.b);
	float3 MathVecConstuct_5078 = float3(uiConst_nm_1, uiConst_nm_1, (1.0 / nmDepth));
	float3 MathNormalize_8794 = normalize(MathVecConstuct_5078);		//Normalize 
	float3 Normal = float3(0,0,1);	//tangent space normal vector 
	float3 MathIf_3511;
	if (uiConst_nm_1 == useNormalmap) MathIf_3511 = (MathVecConstuct_4834 * MathNormalize_8794); else MathIf_3511 = Normal; 
	float3 MathNormalize_9422 = normalize(MathIf_3511);		//Normalize 
	//this code was added by the World Space Transform Node 
	float3 Nn = normalize(In.worldNormal); 		//input the vectors required for tangent to world space transform 
	float3 Tn = normalize(In.worldTangent); 
	float3 Bn = normalize(In.worldBinormal); 
	#ifdef YUP 
		float3 MathWorldXform_1017 = ( Nn * MathNormalize_9422.z ) + (MathNormalize_9422.x * Tn ) + ( MathNormalize_9422.y * -Bn); 
	#else 
		float3 MathWorldXform_1017 = ( Nn * MathNormalize_9422.z ) + (MathNormalize_9422.x * Bn ) + ( MathNormalize_9422.y * -Tn); 
	#endif 
	float2 CustomCode_8951 = (float2(0.5,0.5) + float2(0.5, -0.5) * float2(normalize(mul(ViewIXf, MathWorldXform_1017).xyz).xy)

);
	float4 LitSphere = tex2D(LitSphereSampler, CustomCode_8951.xy);
	float3 MathOperator_6268 = (LitSphere.rgb * litSphereStrength) * useLitSphere;
	float UIConst_rim_is_1 = 1.0; 
	float3 rimBlack = float3(0.0f, 0.0f, 0.0f );
	float3 vec_rimOffs = float3(rimOffsX, rimOffsY, rimOffsZ);
	float3 MathIf_rl_2;
	if (UIBool_rim_offsv == UIConst_rim_is_1) MathIf_rl_2 = rimBlack.rgb; else MathIf_rl_2 = vec_rimOffs; 
	float3 V = normalize(In.eyeVec.xyz);		//normalized eye vector 
	float3 MathNormalize_rl_1 = normalize((MathIf_rl_2 + V));		//Normalize 
	float UIConst_rl_is_0 = 0.0; 
	float3 MathIf_rl_1;
	if (disableNMforRim == UIConst_rl_is_0) MathIf_rl_1 = MathNormalize_9422; else MathIf_rl_1 = Normal; 
	float MathDotProduct_rl_1 = saturate(dot(MathNormalize_rl_1,MathIf_rl_1)); 		//clamped dot product 
	float MathPow_rl_1 = pow((rimRange / (0.01 + MathDotProduct_rl_1)),rimContrast);		//x to the power of y 
	float rimMin = 0.0; 
	float rimMax = 1.0; 
	float MathClamp_rl_1 = clamp(MathPow_rl_1, rimMin, rimMax); 
	float3 MathOperator_8286 = (MathClamp_rl_1 * rimColour.rgb) * useRimlight;
	#ifdef YUP 
		float3 MathWorldXform_7495 = ( Nn * MathNormalize_9422.z ) + (MathNormalize_9422.x * Tn ) + ( MathNormalize_9422.y * -Bn); 
	#else 
		float3 MathWorldXform_7495 = ( Nn * MathNormalize_9422.z ) + (MathNormalize_9422.x * Bn ) + ( MathNormalize_9422.y * -Tn); 
	#endif 
	float3 MathReflect_3904 = reflect(In.viewDir, MathWorldXform_7495);		//Compute the reflection vector 
	float3 cubeMapInputVector = MathReflect_3904.xyz;
	#ifdef YUP 
	#else 
	cubeMapInputVector.xyz = cubeMapInputVector.xzy;  //swizzle required for Max 
	#endif 
	float4 cubeMap = texCUBE(cubeMapSampler, cubeMapInputVector);
	float4 cubeMapMask = tex2D(cubeMapMaskSampler, In.texCoord.xy);
	float UIConst_dif_is_1 = 1.0; 
	float4 INVertColor_7535 = In.color; 		//bringing in the vertex color 
	float3 UIColor_2605 = float3(1.0f, 1.0f, 1.0f );
	float3 MathIf_9785;
	if (useVertexColours == UIConst_dif_is_1) MathIf_9785 = INVertColor_7535.rgb; else MathIf_9785 = UIColor_2605.rgb; 
	float4 diffuseMap = tex2D(diffuseMapSampler, In.texCoord.xy);
	float3 MathIf_6778;
	if (useDiffuseMap == UIConst_dif_is_1) MathIf_6778 = diffuseMap.rgb; else MathIf_6778 = diffuseColour.rgb; 
	float3 MathOperator_7139 = MathIf_9785 * MathIf_6778;
	float3 MathOperator_1067 = (((cubeMapStrength * cubeMap.rgb) * (1.0 - cubeMapMask.rgb)) * useCubeMap) + (MathOperator_7139 * diffuseToAmbient);
	float3 MathOperator_3295 = ((MathOperator_6421 + MathOperator_6268) + MathOperator_8286) + MathOperator_1067;
	float3 input1 = MathOperator_3295; 
	float uiConst_opm_1 = 1.0; 
	float4 opacityMap = tex2D(opacityMapSampler, In.texCoord.xy);
	float MathIf_3401;
	if (useOpacityMap == uiConst_opm_1) MathIf_3401 = opacityMap.a; else MathIf_3401 = opacityValue; 
	float input3 = MathIf_3401; 

	float4 ret =  float4(input1, 1); 
	ret.a = input3 ; 
	return ret; 
} 

// Vertex Shader: 
v2fT1 vT1(a2vT1 In, uniform float3 lightPos, uniform int lightType, uniform float3 lightDir) 
{ 
	v2fT1 Out = (v2fT1)0; 
	Out.position = mul(In.position, wvp);				//transform vert position to homogeneous clip space 

	//this code was added by the Vertex Color Node 
	Out.color = float4(In.vertcol.rgb, In.vertalpha.r); 

	In.texCoord += float2(0.0,1.0);		//this fixes Max's V texcoord which is off by one 
	Out.texCoord = In.texCoord;						//pass through texture coordinates from channel 1 
	//this code was added by the Light Vector Node 
	float3x3 objTangentXf;								//build object to tangent space transform matrix 
	#ifdef YUP 
	objTangentXf[0] = In.tangent.xyz; 
	objTangentXf[1] = -In.binormal.xyz; 
	#else 
	objTangentXf[0] = In.binormal.xyz; 
	objTangentXf[1] = -In.tangent.xyz; 
	#endif 
	objTangentXf[2] = In.normal.xyz; 
	float3 wsLPos = mul(In.position, world).xyz;			//put the vert position in world space 
	float3 wsLVec = lightPos - wsLPos;    //cast a ray to the light 
	float3 osLVec = mul(wsLVec, worldI).xyz;  //transform the world space light vector to object space 
	Out.lightVec = mul(objTangentXf, osLVec);			//tangent space light vector passed out 
	//these three lines were added by the Eye Vector Node 
	float4 osIPos = mul(viewInv[3], worldI);			//put world space eye position in object space 
	float3 osIVec = osIPos.xyz - In.position.xyz;		//object space eye vector 
	Out.eyeVec = mul(objTangentXf, osIVec);				//tangent space eye vector passed out 

	return Out; 
} 

// Pixel Shader: 
float4 fT1(v2fT1 In, uniform float3 lightDir, uniform float4 lightColor, uniform float4 lightAttenuation, uniform float lightHotspot, uniform float lightFalloff, uniform int lightType, uniform int lightattenType, uniform int lightconeType, uniform bool lightCastShadows, uniform int shadowPassCount) : COLOR 
{ 

	float UIConst_dif_is_1 = 1.0; 
	float4 INVertColor_7535 = In.color; 		//bringing in the vertex color 
	float3 UIColor_2605 = float3(1.0f, 1.0f, 1.0f );
	float3 MathIf_9785;
	if (useVertexColours == UIConst_dif_is_1) MathIf_9785 = INVertColor_7535.rgb; else MathIf_9785 = UIColor_2605.rgb; 
	float4 diffuseMap = tex2D(diffuseMapSampler, In.texCoord.xy);
	float3 MathIf_6778;
	if (useDiffuseMap == UIConst_dif_is_1) MathIf_6778 = diffuseMap.rgb; else MathIf_6778 = diffuseColour.rgb; 
	float3 MathOperator_7139 = MathIf_9785 * MathIf_6778;
	float UIConst_ram_is_1 = 1.0; 
	float3 flatShadedColour = float3(0.0f, 0.0f, 0.0f );
	float3 L = normalize(In.lightVec.xyz);	//normalized light vector 
	float uiConst_nm_1 = 1.0; 
	float uiConst_nm_0 = 0.0; 
	float4 NormalMap = tex2D(NormalMapSampler, In.texCoord.xy);
	NormalMap.xyz = NormalMap.xyz * 2 - 1;		//expand to -1 to 1 range 
	NormalMap.rgb = normalize(NormalMap.rgb); 		//normalized the normal vector 
	float MathIf_586;
	if (invertRed == uiConst_nm_1) MathIf_586 = (uiConst_nm_0 - NormalMap.r); else MathIf_586 = NormalMap.r; 
	float MathIf_7612;
	if (invertGreen == uiConst_nm_1) MathIf_7612 = (uiConst_nm_0 - NormalMap.g); else MathIf_7612 = NormalMap.g; 
	float3 MathVecConstuct_4834 = float3(MathIf_586, MathIf_7612, NormalMap.b);
	float3 MathVecConstuct_5078 = float3(uiConst_nm_1, uiConst_nm_1, (1.0 / nmDepth));
	float3 MathNormalize_8794 = normalize(MathVecConstuct_5078);		//Normalize 
	float3 Normal = float3(0,0,1);	//tangent space normal vector 
	float3 MathIf_3511;
	if (uiConst_nm_1 == useNormalmap) MathIf_3511 = (MathVecConstuct_4834 * MathNormalize_8794); else MathIf_3511 = Normal; 
	float3 MathNormalize_9422 = normalize(MathIf_3511);		//Normalize 
	float NdotL_dif = dot(L,MathNormalize_9422);		//dot product 
	float UIConst_ram_is_05 = 0.5; 
	float MathPow_ramp = pow(((NdotL_dif * UIConst_ram_is_05) + UIConst_ram_is_05),rampRange);		//x to the power of y 
	float2 MathVecConstuct_564 = float2(MathPow_ramp, UIConst_ram_is_1);
	float4 rampTexture = tex2D(rampTextureSampler, MathVecConstuct_564.xy);
	float MathPow_2577 = pow(rampTexture.r,rampContrast);		//x to the power of y 
	float MathPow_1068 = pow(rampTexture.g,rampContrast);		//x to the power of y 
	float MathPow_8169 = pow(rampTexture.b,rampContrast);		//x to the power of y 
	float3 MathVecConstuct_2788 = float3(MathPow_2577, MathPow_1068, MathPow_8169);
	float3 noRampColour = float3(0.501961f, 0.501961f, 0.501961f );
	float3 MathIf_1998;
	if (useRampedShading == UIConst_ram_is_1) MathIf_1998 = MathVecConstuct_2788; else MathIf_1998 = (NdotL_dif * noRampColour.rgb); 
	float3 MathIf_3928;
	if (disableShading == UIConst_ram_is_1) MathIf_3928 = flatShadedColour.rgb; else MathIf_3928 = MathIf_1998; 
	float4 specMap = tex2D(specMapSampler, In.texCoord.xy);
	float3 V = normalize(In.eyeVec.xyz);		//normalized eye vector 
	float3 NormalizedHalfAngle = normalize((L + V));		//Normalize 
	float NdotH_specular = saturate(dot(NormalizedHalfAngle,MathNormalize_9422)); 		//clamped dot product 
	float UIConst_spec_255 = 255.0; 
	float4 glossMap = tex2D(glossMapSampler, In.texCoord.xy);
	float MathOperator_3845 = (useGlossMap * glossMap.r) + glossBoost;
	float UIConst_spec_debug = 0.04; 
	float NdotH_pow_Glossiness = pow(NdotH_specular,((UIConst_spec_255 * ((MathOperator_3845 * MathOperator_3845) + UIConst_spec_debug)) * glossLevel));		//x to the power of y 
	float3 MathOperator_477 = (((specMap.rgb * useSpecMap) + specBoost) * NdotH_pow_Glossiness) * specLevel;
	float3 MathOperator_4897 = MathIf_3928 + MathOperator_477;
	float uiConst_light_1 = 1.0; 
	float One_ = 1.0; 
	float3 L_4377 = In.lightVec.xyz;		//unnormalized light vector 
	float LengthOfLightVector = length(L_4377);		//Measure the length of the vector 
	float MathIf_8936;
	if (uiConst_light_1 == useLightAttenuation) MathIf_8936 = ((One_ / ((((LengthOfLightVector * LengthOfLightVector) * Attenuation3) + (LengthOfLightVector * Attenuation2)) + Attenuation1)) * AttenuationScale); else MathIf_8936 = uiConst_light_1; 
	float3 MathOperator_4706 = (lightColor.rgb * MathIf_8936) * lightBoost;
	float3 MathOperator_2814 = MathOperator_477 * specOverlay;
	float UIConst_sss_1 = 1.0; 
	float4 sssMask = tex2D(sssMaskSampler, In.texCoord.xy);
	float MathIf_sss_1;
	if (useSSSmask == UIConst_sss_1) MathIf_sss_1 = sssMask.r; else MathIf_sss_1 = UIConst_sss_1; 
	float MathDotProduct_sss_1 = saturate(dot(MathNormalize_9422,L)); 		//clamped dot product 
	float3 MathNegate_sss = -L;		//Make the value negative 
	float MathDotProduct_sss_2 = saturate(dot(MathNormalize_9422,MathNegate_sss)); 		//clamped dot product 
	float MathPow_sss = pow(((1.0 / (((MathDotProduct_sss_1 + MathDotProduct_sss_2) + 0.01) * sssRange)) * 0.1),sssContrast);		//x to the power of y 
	float UIConst_sss_0 = 0.0; 
	float MathClamp_sss = clamp(MathPow_sss, UIConst_sss_0, UIConst_sss_1); 
	float3 UIColor_sss_black = float3(0.0f, 0.0f, 0.0f );
	float3 MathIf_5586;
	if (useSSS == UIConst_sss_1) MathIf_5586 = (MathIf_sss_1 * (MathClamp_sss * sssColor.rgb)); else MathIf_5586 = UIColor_sss_black.rgb; 
	float3 MathOperator_9693 = ((MathOperator_7139 * (MathOperator_4897 * MathOperator_4706)) + MathOperator_2814) + MathIf_5586;
	float3 input2 = MathOperator_9693; 
	float uiConst_opm_1 = 1.0; 
	float4 opacityMap = tex2D(opacityMapSampler, In.texCoord.xy);
	float MathIf_3401;
	if (useOpacityMap == uiConst_opm_1) MathIf_3401 = opacityMap.a; else MathIf_3401 = opacityValue; 
	float input3 = MathIf_3401; 

	float4 ret =  float4(input2, 1); 
	ret.a = input3 ; 
	return ret; 
} 

technique one_Light  
{  
	pass ambient  
    {		 
		VertexShader = compile vs_3_0 avT1(light1Pos, light1Type, light1Dir); 
		ZEnable = true; 
		ZWriteEnable = true; 
		CullMode = cw; 
		ShadeMode = Gouraud;
		AlphaBlendEnable = true; 
		SrcBlend = SrcAlpha; 
		DestBlend = InvSrcAlpha; 
		AlphaTestEnable = FALSE; 
		PixelShader = compile ps_3_0 afT1(light1Dir, light1Color, light1Attenuation, light1Hotspot, light1Falloff, light1Type, light1attenType, light1coneType, light1CastShadows, 1); 
	}  

	pass light1  
    {		 
		VertexShader = compile vs_3_0 vT1(light1Pos, light1Type, light1Dir); 
		ZEnable = true; 
		CullMode = cw; 
		ShadeMode = Gouraud;
		AlphaBlendEnable = true; 
		ZWriteEnable = true; 
		ZFunc = LessEqual; 
		SrcBlend = SrcAlpha; 
		DestBlend = One; 
		AlphaTestEnable = FALSE; 
		PixelShader = compile ps_3_0 fT1(light1Dir, light1Color, light1Attenuation, light1Hotspot, light1Falloff, light1Type, light1attenType, light1coneType, light1CastShadows, 1); 
	}  

}  



/*============================================================================
 ============= three_Lights TECHNIQUE ============= 
============================================================================*/


// this function does the different types of light attenuation 
float attenuation_funcT2(int lightattenType, float4 lightAttenuation, float3 lightVec) 
{ 
	float att = 1.0; 
	return att; 
} 
	 
// this function does the different types of cone angle 
float coneangle_funcT2(int lightconeType, float lightHotspot, float lightFalloff, float3 lightVec, float3 lightDir) 
{ 
	float cone = 1.0; 
	return cone; 
} 

/************** light info **************/ 

float3 light2Dir : Direction 
< 
	string UIName = "Light 2 Direction"; 
	string Object = "TargetLight"; 
	string Space = "World"; 
		int refID = 2; 
> = {100.0f, 100.0f, 100.0f}; 

float3 light2Pos : POSITION 
< 
	string UIName = "Light 2 Position"; 
	string Object = "PointLight"; 
	string Space = "World"; 
		int refID = 2; 
> = {100.0f, 100.0f, 100.0f}; 

float4 light2Color : LIGHTCOLOR <int LightRef = 2; string UIWidget = "None"; > = { 1.0f, 1.0f, 1.0f, 1.0f}; 
float4 light2Attenuation : Attenuation <int LightRef = 2; string UIWidget = "None"; > = {20.0f, 30.0f, 0.0f, 100.0f}; 
float light2Hotspot : HotSpot <int LightRef = 2; string UIWidget = "None"; > = { 43.0f }; 
float light2Falloff : FallOff <int LightRef = 2; string UIWidget = "None"; > = { 45.0f }; 

#define light2Type 1
#define light2attenType 0
#define light2coneType 0
#define light2CastShadows false

//---------------------------------- 

float3 light3Dir : Direction 
< 
	string UIName = "Light 3 Direction"; 
	string Object = "TargetLight"; 
	string Space = "World"; 
		int refID = 3; 
> = {100.0f, 100.0f, 100.0f}; 

float3 light3Pos : POSITION 
< 
	string UIName = "Light 3 Position"; 
	string Object = "PointLight"; 
	string Space = "World"; 
		int refID = 3; 
> = {100.0f, 100.0f, 100.0f}; 

float4 light3Color : LIGHTCOLOR <int LightRef = 3; string UIWidget = "None"; > = { 1.0f, 1.0f, 1.0f, 1.0f}; 
float4 light3Attenuation : Attenuation <int LightRef = 3; string UIWidget = "None"; > = {20.0f, 30.0f, 0.0f, 100.0f}; 
float light3Hotspot : HotSpot <int LightRef = 3; string UIWidget = "None"; > = { 43.0f }; 
float light3Falloff : FallOff <int LightRef = 3; string UIWidget = "None"; > = { 45.0f }; 

#define light3Type 1
#define light3attenType 0
#define light3coneType 0
#define light3CastShadows false

//---------------------------------- 


// create the light vector 
float3 lightVec_funcT2(float3 worldSpacePos, float3 lightVector, float3x3 objTangentXf, int lightType) 
{ 
	float3 lightVec = mul(objTangentXf, (mul((lightVector - worldSpacePos), worldI).xyz)); 
	return lightVec; 
} 

// input from application 
	struct a2vT2 { 
	float4 position		: POSITION; 

	float2 texCoord		: TEXCOORD0; 
	float4 tangent		: TANGENT; 
	float4 binormal		: BINORMAL; 
	float4 normal		: NORMAL; 
	float3 vertcol		: TEXCOORD3; 
	float vertalpha 	: TEXCOORD4; 

}; 

// output to fragment program 
struct v2fT2 { 
        float4 position    		: POSITION; 

	float2 texCoord			: TEXCOORD0; 
        float3 worldTangent  	: TEXCOORD1; 
        float3 worldBinormal 	: TEXCOORD2; 
        float3 worldNormal   	: TEXCOORD3; 
        float3 eyeVec	    	: TEXCOORD4; 
        float3 viewDir	    	: TEXCOORD5; 
        float4 color    		: COLOR0; 
        float3 lightVec    		: TEXCOORD6; 

}; 

// Ambient Pass Vertex Shader: 
v2fT2 avT2(a2vT2 In, uniform float3 lightPos, uniform int lightType, uniform float3 lightDir) 
{ 
	v2fT2 Out = (v2fT2)0; 
	Out.position = mul(In.position, wvp);				//transform vert position to homogeneous clip space 

	In.texCoord += float2(0.0,1.0);		//this fixes Max's V texcoord which is off by one 
	Out.texCoord = In.texCoord;						//pass through texture coordinates from channel 1 
	//this code was added by the World Space Transform Node 
	Out.worldNormal = mul(In.normal, worldIT).xyz;		//compute world space normal 
	Out.worldBinormal = mul(In.binormal, worldIT).xyz;	//compute world space binormal 
	Out.worldTangent = mul(In.tangent, worldIT).xyz;		//compute world space tangent 
	//this code was added by the Eye Vector Node 
	float3x3 objTangentXf;								//build object to tangent space transform matrix 
	#ifdef YUP 
	objTangentXf[0] = In.tangent.xyz; 
	objTangentXf[1] = -In.binormal.xyz; 
	#else 
	objTangentXf[0] = In.binormal.xyz; 
	objTangentXf[1] = -In.tangent.xyz; 
	#endif 
	objTangentXf[2] = In.normal.xyz; 
	//these three lines were added by the Eye Vector Node 
	float4 osIPos = mul(viewInv[3], worldI);			//put world space eye position in object space 
	float3 osIVec = osIPos.xyz - In.position.xyz;		//object space eye vector 
	Out.eyeVec = mul(objTangentXf, osIVec);				//tangent space eye vector passed out 
	//this code was added by the World Space Transform Node 
	Out.viewDir = mul(In.position, world) - viewInv[3]; 
	//this code was added by the Vertex Color Node 
	Out.color = float4(In.vertcol.rgb, In.vertalpha.r); 


	return Out; 
} 

// Ambient Pass Pixel Shader: 
float4 afT2(v2fT2 In, uniform float3 lightDir, uniform float4 lightColor, uniform float4 lightAttenuation, uniform float lightHotspot, uniform float lightFalloff, uniform int lightType, uniform int lightattenType, uniform int lightconeType, uniform bool lightCastShadows, uniform int shadowPassCount) : COLOR 
{ 

	float4 selfiluminationMap = tex2D(selfiluminationMapSampler, In.texCoord.xy);
	float3 MathOperator_6421 = useSelfilum * selfiluminationMap.rgb;
	float uiConst_nm_1 = 1.0; 
	float uiConst_nm_0 = 0.0; 
	float4 NormalMap = tex2D(NormalMapSampler, In.texCoord.xy);
	NormalMap.xyz = NormalMap.xyz * 2 - 1;		//expand to -1 to 1 range 
	NormalMap.rgb = normalize(NormalMap.rgb); 		//normalized the normal vector 
	float MathIf_586;
	if (invertRed == uiConst_nm_1) MathIf_586 = (uiConst_nm_0 - NormalMap.r); else MathIf_586 = NormalMap.r; 
	float MathIf_7612;
	if (invertGreen == uiConst_nm_1) MathIf_7612 = (uiConst_nm_0 - NormalMap.g); else MathIf_7612 = NormalMap.g; 
	float3 MathVecConstuct_4834 = float3(MathIf_586, MathIf_7612, NormalMap.b);
	float3 MathVecConstuct_5078 = float3(uiConst_nm_1, uiConst_nm_1, (1.0 / nmDepth));
	float3 MathNormalize_8794 = normalize(MathVecConstuct_5078);		//Normalize 
	float3 Normal = float3(0,0,1);	//tangent space normal vector 
	float3 MathIf_3511;
	if (uiConst_nm_1 == useNormalmap) MathIf_3511 = (MathVecConstuct_4834 * MathNormalize_8794); else MathIf_3511 = Normal; 
	float3 MathNormalize_9422 = normalize(MathIf_3511);		//Normalize 
	//this code was added by the World Space Transform Node 
	float3 Nn = normalize(In.worldNormal); 		//input the vectors required for tangent to world space transform 
	float3 Tn = normalize(In.worldTangent); 
	float3 Bn = normalize(In.worldBinormal); 
	#ifdef YUP 
		float3 MathWorldXform_1017 = ( Nn * MathNormalize_9422.z ) + (MathNormalize_9422.x * Tn ) + ( MathNormalize_9422.y * -Bn); 
	#else 
		float3 MathWorldXform_1017 = ( Nn * MathNormalize_9422.z ) + (MathNormalize_9422.x * Bn ) + ( MathNormalize_9422.y * -Tn); 
	#endif 
	float2 CustomCode_8951 = (float2(0.5,0.5) + float2(0.5, -0.5) * float2(normalize(mul(ViewIXf, MathWorldXform_1017).xyz).xy)

);
	float4 LitSphere = tex2D(LitSphereSampler, CustomCode_8951.xy);
	float3 MathOperator_6268 = (LitSphere.rgb * litSphereStrength) * useLitSphere;
	float UIConst_rim_is_1 = 1.0; 
	float3 rimBlack = float3(0.0f, 0.0f, 0.0f );
	float3 vec_rimOffs = float3(rimOffsX, rimOffsY, rimOffsZ);
	float3 MathIf_rl_2;
	if (UIBool_rim_offsv == UIConst_rim_is_1) MathIf_rl_2 = rimBlack.rgb; else MathIf_rl_2 = vec_rimOffs; 
	float3 V = normalize(In.eyeVec.xyz);		//normalized eye vector 
	float3 MathNormalize_rl_1 = normalize((MathIf_rl_2 + V));		//Normalize 
	float UIConst_rl_is_0 = 0.0; 
	float3 MathIf_rl_1;
	if (disableNMforRim == UIConst_rl_is_0) MathIf_rl_1 = MathNormalize_9422; else MathIf_rl_1 = Normal; 
	float MathDotProduct_rl_1 = saturate(dot(MathNormalize_rl_1,MathIf_rl_1)); 		//clamped dot product 
	float MathPow_rl_1 = pow((rimRange / (0.01 + MathDotProduct_rl_1)),rimContrast);		//x to the power of y 
	float rimMin = 0.0; 
	float rimMax = 1.0; 
	float MathClamp_rl_1 = clamp(MathPow_rl_1, rimMin, rimMax); 
	float3 MathOperator_8286 = (MathClamp_rl_1 * rimColour.rgb) * useRimlight;
	#ifdef YUP 
		float3 MathWorldXform_7495 = ( Nn * MathNormalize_9422.z ) + (MathNormalize_9422.x * Tn ) + ( MathNormalize_9422.y * -Bn); 
	#else 
		float3 MathWorldXform_7495 = ( Nn * MathNormalize_9422.z ) + (MathNormalize_9422.x * Bn ) + ( MathNormalize_9422.y * -Tn); 
	#endif 
	float3 MathReflect_3904 = reflect(In.viewDir, MathWorldXform_7495);		//Compute the reflection vector 
	float3 cubeMapInputVector = MathReflect_3904.xyz;
	#ifdef YUP 
	#else 
	cubeMapInputVector.xyz = cubeMapInputVector.xzy;  //swizzle required for Max 
	#endif 
	float4 cubeMap = texCUBE(cubeMapSampler, cubeMapInputVector);
	float4 cubeMapMask = tex2D(cubeMapMaskSampler, In.texCoord.xy);
	float UIConst_dif_is_1 = 1.0; 
	float4 INVertColor_7535 = In.color; 		//bringing in the vertex color 
	float3 UIColor_2605 = float3(1.0f, 1.0f, 1.0f );
	float3 MathIf_9785;
	if (useVertexColours == UIConst_dif_is_1) MathIf_9785 = INVertColor_7535.rgb; else MathIf_9785 = UIColor_2605.rgb; 
	float4 diffuseMap = tex2D(diffuseMapSampler, In.texCoord.xy);
	float3 MathIf_6778;
	if (useDiffuseMap == UIConst_dif_is_1) MathIf_6778 = diffuseMap.rgb; else MathIf_6778 = diffuseColour.rgb; 
	float3 MathOperator_7139 = MathIf_9785 * MathIf_6778;
	float3 MathOperator_1067 = (((cubeMapStrength * cubeMap.rgb) * (1.0 - cubeMapMask.rgb)) * useCubeMap) + (MathOperator_7139 * diffuseToAmbient);
	float3 MathOperator_3295 = ((MathOperator_6421 + MathOperator_6268) + MathOperator_8286) + MathOperator_1067;
	float3 input1 = MathOperator_3295; 
	float uiConst_opm_1 = 1.0; 
	float4 opacityMap = tex2D(opacityMapSampler, In.texCoord.xy);
	float MathIf_3401;
	if (useOpacityMap == uiConst_opm_1) MathIf_3401 = opacityMap.a; else MathIf_3401 = opacityValue; 
	float input3 = MathIf_3401; 

	float4 ret =  float4(input1, 1); 
	ret.a = input3 ; 
	return ret; 
} 

// Vertex Shader: 
v2fT2 vT2(a2vT2 In, uniform float3 lightPos, uniform int lightType, uniform float3 lightDir) 
{ 
	v2fT2 Out = (v2fT2)0; 
	Out.position = mul(In.position, wvp);				//transform vert position to homogeneous clip space 

	//this code was added by the Vertex Color Node 
	Out.color = float4(In.vertcol.rgb, In.vertalpha.r); 

	In.texCoord += float2(0.0,1.0);		//this fixes Max's V texcoord which is off by one 
	Out.texCoord = In.texCoord;						//pass through texture coordinates from channel 1 
	//this code was added by the Light Vector Node 
	float3x3 objTangentXf;								//build object to tangent space transform matrix 
	#ifdef YUP 
	objTangentXf[0] = In.tangent.xyz; 
	objTangentXf[1] = -In.binormal.xyz; 
	#else 
	objTangentXf[0] = In.binormal.xyz; 
	objTangentXf[1] = -In.tangent.xyz; 
	#endif 
	objTangentXf[2] = In.normal.xyz; 
	float3 wsLPos = mul(In.position, world).xyz;			//put the vert position in world space 
	float3 wsLVec = lightPos - wsLPos;    //cast a ray to the light 
	float3 osLVec = mul(wsLVec, worldI).xyz;  //transform the world space light vector to object space 
	Out.lightVec = mul(objTangentXf, osLVec);			//tangent space light vector passed out 
	//these three lines were added by the Eye Vector Node 
	float4 osIPos = mul(viewInv[3], worldI);			//put world space eye position in object space 
	float3 osIVec = osIPos.xyz - In.position.xyz;		//object space eye vector 
	Out.eyeVec = mul(objTangentXf, osIVec);				//tangent space eye vector passed out 

	return Out; 
} 

// Pixel Shader: 
float4 fT2(v2fT2 In, uniform float3 lightDir, uniform float4 lightColor, uniform float4 lightAttenuation, uniform float lightHotspot, uniform float lightFalloff, uniform int lightType, uniform int lightattenType, uniform int lightconeType, uniform bool lightCastShadows, uniform int shadowPassCount) : COLOR 
{ 

	float UIConst_dif_is_1 = 1.0; 
	float4 INVertColor_7535 = In.color; 		//bringing in the vertex color 
	float3 UIColor_2605 = float3(1.0f, 1.0f, 1.0f );
	float3 MathIf_9785;
	if (useVertexColours == UIConst_dif_is_1) MathIf_9785 = INVertColor_7535.rgb; else MathIf_9785 = UIColor_2605.rgb; 
	float4 diffuseMap = tex2D(diffuseMapSampler, In.texCoord.xy);
	float3 MathIf_6778;
	if (useDiffuseMap == UIConst_dif_is_1) MathIf_6778 = diffuseMap.rgb; else MathIf_6778 = diffuseColour.rgb; 
	float3 MathOperator_7139 = MathIf_9785 * MathIf_6778;
	float UIConst_ram_is_1 = 1.0; 
	float3 flatShadedColour = float3(0.0f, 0.0f, 0.0f );
	float3 L = normalize(In.lightVec.xyz);	//normalized light vector 
	float uiConst_nm_1 = 1.0; 
	float uiConst_nm_0 = 0.0; 
	float4 NormalMap = tex2D(NormalMapSampler, In.texCoord.xy);
	NormalMap.xyz = NormalMap.xyz * 2 - 1;		//expand to -1 to 1 range 
	NormalMap.rgb = normalize(NormalMap.rgb); 		//normalized the normal vector 
	float MathIf_586;
	if (invertRed == uiConst_nm_1) MathIf_586 = (uiConst_nm_0 - NormalMap.r); else MathIf_586 = NormalMap.r; 
	float MathIf_7612;
	if (invertGreen == uiConst_nm_1) MathIf_7612 = (uiConst_nm_0 - NormalMap.g); else MathIf_7612 = NormalMap.g; 
	float3 MathVecConstuct_4834 = float3(MathIf_586, MathIf_7612, NormalMap.b);
	float3 MathVecConstuct_5078 = float3(uiConst_nm_1, uiConst_nm_1, (1.0 / nmDepth));
	float3 MathNormalize_8794 = normalize(MathVecConstuct_5078);		//Normalize 
	float3 Normal = float3(0,0,1);	//tangent space normal vector 
	float3 MathIf_3511;
	if (uiConst_nm_1 == useNormalmap) MathIf_3511 = (MathVecConstuct_4834 * MathNormalize_8794); else MathIf_3511 = Normal; 
	float3 MathNormalize_9422 = normalize(MathIf_3511);		//Normalize 
	float NdotL_dif = dot(L,MathNormalize_9422);		//dot product 
	float UIConst_ram_is_05 = 0.5; 
	float MathPow_ramp = pow(((NdotL_dif * UIConst_ram_is_05) + UIConst_ram_is_05),rampRange);		//x to the power of y 
	float2 MathVecConstuct_564 = float2(MathPow_ramp, UIConst_ram_is_1);
	float4 rampTexture = tex2D(rampTextureSampler, MathVecConstuct_564.xy);
	float MathPow_2577 = pow(rampTexture.r,rampContrast);		//x to the power of y 
	float MathPow_1068 = pow(rampTexture.g,rampContrast);		//x to the power of y 
	float MathPow_8169 = pow(rampTexture.b,rampContrast);		//x to the power of y 
	float3 MathVecConstuct_2788 = float3(MathPow_2577, MathPow_1068, MathPow_8169);
	float3 noRampColour = float3(0.501961f, 0.501961f, 0.501961f );
	float3 MathIf_1998;
	if (useRampedShading == UIConst_ram_is_1) MathIf_1998 = MathVecConstuct_2788; else MathIf_1998 = (NdotL_dif * noRampColour.rgb); 
	float3 MathIf_3928;
	if (disableShading == UIConst_ram_is_1) MathIf_3928 = flatShadedColour.rgb; else MathIf_3928 = MathIf_1998; 
	float4 specMap = tex2D(specMapSampler, In.texCoord.xy);
	float3 V = normalize(In.eyeVec.xyz);		//normalized eye vector 
	float3 NormalizedHalfAngle = normalize((L + V));		//Normalize 
	float NdotH_specular = saturate(dot(NormalizedHalfAngle,MathNormalize_9422)); 		//clamped dot product 
	float UIConst_spec_255 = 255.0; 
	float4 glossMap = tex2D(glossMapSampler, In.texCoord.xy);
	float MathOperator_3845 = (useGlossMap * glossMap.r) + glossBoost;
	float UIConst_spec_debug = 0.04; 
	float NdotH_pow_Glossiness = pow(NdotH_specular,((UIConst_spec_255 * ((MathOperator_3845 * MathOperator_3845) + UIConst_spec_debug)) * glossLevel));		//x to the power of y 
	float3 MathOperator_477 = (((specMap.rgb * useSpecMap) + specBoost) * NdotH_pow_Glossiness) * specLevel;
	float3 MathOperator_4897 = MathIf_3928 + MathOperator_477;
	float uiConst_light_1 = 1.0; 
	float One_ = 1.0; 
	float3 L_4377 = In.lightVec.xyz;		//unnormalized light vector 
	float LengthOfLightVector = length(L_4377);		//Measure the length of the vector 
	float MathIf_8936;
	if (uiConst_light_1 == useLightAttenuation) MathIf_8936 = ((One_ / ((((LengthOfLightVector * LengthOfLightVector) * Attenuation3) + (LengthOfLightVector * Attenuation2)) + Attenuation1)) * AttenuationScale); else MathIf_8936 = uiConst_light_1; 
	float3 MathOperator_4706 = (lightColor.rgb * MathIf_8936) * lightBoost;
	float3 MathOperator_2814 = MathOperator_477 * specOverlay;
	float UIConst_sss_1 = 1.0; 
	float4 sssMask = tex2D(sssMaskSampler, In.texCoord.xy);
	float MathIf_sss_1;
	if (useSSSmask == UIConst_sss_1) MathIf_sss_1 = sssMask.r; else MathIf_sss_1 = UIConst_sss_1; 
	float MathDotProduct_sss_1 = saturate(dot(MathNormalize_9422,L)); 		//clamped dot product 
	float3 MathNegate_sss = -L;		//Make the value negative 
	float MathDotProduct_sss_2 = saturate(dot(MathNormalize_9422,MathNegate_sss)); 		//clamped dot product 
	float MathPow_sss = pow(((1.0 / (((MathDotProduct_sss_1 + MathDotProduct_sss_2) + 0.01) * sssRange)) * 0.1),sssContrast);		//x to the power of y 
	float UIConst_sss_0 = 0.0; 
	float MathClamp_sss = clamp(MathPow_sss, UIConst_sss_0, UIConst_sss_1); 
	float3 UIColor_sss_black = float3(0.0f, 0.0f, 0.0f );
	float3 MathIf_5586;
	if (useSSS == UIConst_sss_1) MathIf_5586 = (MathIf_sss_1 * (MathClamp_sss * sssColor.rgb)); else MathIf_5586 = UIColor_sss_black.rgb; 
	float3 MathOperator_9693 = ((MathOperator_7139 * (MathOperator_4897 * MathOperator_4706)) + MathOperator_2814) + MathIf_5586;
	float3 input2 = MathOperator_9693; 
	float uiConst_opm_1 = 1.0; 
	float4 opacityMap = tex2D(opacityMapSampler, In.texCoord.xy);
	float MathIf_3401;
	if (useOpacityMap == uiConst_opm_1) MathIf_3401 = opacityMap.a; else MathIf_3401 = opacityValue; 
	float input3 = MathIf_3401; 

	float4 ret =  float4(input2, 1); 
	ret.a = input3 ; 
	return ret; 
} 

technique three_Lights  
{  
	pass ambient  
    {		 
		VertexShader = compile vs_3_0 avT2(light1Pos, light1Type, light1Dir); 
		ZEnable = true; 
		ZWriteEnable = true; 
		CullMode = cw; 
		ShadeMode = Gouraud;
		AlphaBlendEnable = true; 
		SrcBlend = SrcAlpha; 
		DestBlend = InvSrcAlpha; 
		AlphaTestEnable = FALSE; 
		PixelShader = compile ps_3_0 afT2(light1Dir, light1Color, light1Attenuation, light1Hotspot, light1Falloff, light1Type, light1attenType, light1coneType, light1CastShadows, 1); 
	}  

	pass light1  
    {		 
		VertexShader = compile vs_3_0 vT2(light1Pos, light1Type, light1Dir); 
		ZEnable = true; 
		CullMode = cw; 
		ShadeMode = Gouraud;
		AlphaBlendEnable = true; 
		ZWriteEnable = true; 
		ZFunc = LessEqual; 
		SrcBlend = SrcAlpha; 
		DestBlend = One; 
		AlphaTestEnable = FALSE; 
		PixelShader = compile ps_3_0 fT2(light1Dir, light1Color, light1Attenuation, light1Hotspot, light1Falloff, light1Type, light1attenType, light1coneType, light1CastShadows, 1); 
	}  

	pass light2  
	{		 
		VertexShader = compile vs_3_0 vT2(light2Pos, light2Type, light2Dir); 
		ZEnable = true; 
		ZWriteEnable = false; 
		ZFunc = LessEqual; 
		CullMode = cw; 
		ShadeMode = Gouraud;
		AlphaBlendEnable = true; 
		AlphaTestEnable = FALSE; 
		SrcBlend = SrcAlpha; 
		DestBlend = One; 
		PixelShader = compile ps_3_0 fT2(light2Dir, light2Color, light2Attenuation, light2Hotspot, light2Falloff, light2Type, light2attenType, light2coneType, light2CastShadows, 2); 
	}  

	pass light3  
	{		 
		VertexShader = compile vs_3_0 vT2(light3Pos, light3Type, light3Dir); 
		ZEnable = true; 
		ZWriteEnable = false; 
		ZFunc = LessEqual; 
		CullMode = cw; 
		ShadeMode = Gouraud;
		AlphaBlendEnable = true; 
		AlphaTestEnable = FALSE; 
		SrcBlend = SrcAlpha; 
		DestBlend = One; 
		PixelShader = compile ps_3_0 fT2(light3Dir, light3Color, light3Attenuation, light3Hotspot, light3Falloff, light3Type, light3attenType, light3coneType, light3CastShadows, 3); 
	}  

}  



/*============================================================================
 ============= ZB TECHNIQUE ============= 
============================================================================*/



// create the light vector 
float3 lightVec_funcT3(float3 worldSpacePos, float3 lightVector, float3x3 objTangentXf, int lightType) 
{ 
	float3 lightVec = mul(objTangentXf, (mul((lightVector - worldSpacePos), worldI).xyz)); 
	return lightVec; 
} 

// input from application 
	struct a2vT3 { 
	float4 position		: POSITION; 

	float2 texCoord		: TEXCOORD0; 
	float4 tangent		: TANGENT; 
	float4 binormal		: BINORMAL; 
	float4 normal		: NORMAL; 
	float3 vertcol		: TEXCOORD3; 
	float vertalpha 	: TEXCOORD4; 

}; 

// output to fragment program 
struct v2fT3 { 
        float4 position    		: POSITION; 

		float2 texCoord			: TEXCOORD0; 
        float3 worldTangent  	: TEXCOORD1; 
        float3 worldBinormal 	: TEXCOORD2; 
        float3 worldNormal   	: TEXCOORD3; 
        float3 viewDir	    	: TEXCOORD4; 
        float4 color    		: COLOR0; 
        float3 eyeVec	    	: TEXCOORD5; 
        float3 lightVec    		: TEXCOORD6; 

}; 

// Ambient Pass Vertex Shader: 
v2fT3 avT3(a2vT3 In, uniform float3 lightPos, uniform int lightType, uniform float3 lightDir) 
{ 
	v2fT3 Out = (v2fT3)0; 
	Out.position = mul(In.position, wvp);				//transform vert position to homogeneous clip space 

	In.texCoord += float2(0.0,1.0);		//this fixes Max's V texcoord which is off by one 
	Out.texCoord = In.texCoord;						//pass through texture coordinates from channel 1 
	//this code was added by the World Space Transform Node 
	Out.worldNormal = mul(In.normal, worldIT).xyz;		//compute world space normal 
	Out.worldBinormal = mul(In.binormal, worldIT).xyz;	//compute world space binormal 
	Out.worldTangent = mul(In.tangent, worldIT).xyz;		//compute world space tangent 
	Out.viewDir = mul(In.position, world) - viewInv[3]; 
	//this code was added by the Vertex Color Node 
	Out.color = float4(In.vertcol.rgb, In.vertalpha.r); 

	//this code was added by the Eye Vector Node 
	float3x3 objTangentXf;								//build object to tangent space transform matrix 
	#ifdef YUP 
	objTangentXf[0] = In.tangent.xyz; 
	objTangentXf[1] = -In.binormal.xyz; 
	#else 
	objTangentXf[0] = In.binormal.xyz; 
	objTangentXf[1] = -In.tangent.xyz; 
	#endif 
	objTangentXf[2] = In.normal.xyz; 
	//these three lines were added by the Eye Vector Node 
	float4 osIPos = mul(viewInv[3], worldI);			//put world space eye position in object space 
	float3 osIVec = osIPos.xyz - In.position.xyz;		//object space eye vector 
	Out.eyeVec = mul(objTangentXf, osIVec);				//tangent space eye vector passed out 

	return Out; 
} 

// Ambient Pass Pixel Shader: 
float4 afT3(v2fT3 In, uniform float3 lightDir, uniform float4 lightColor, uniform float4 lightAttenuation, uniform float lightHotspot, uniform float lightFalloff, uniform int lightType, uniform int lightattenType, uniform int lightconeType, uniform bool lightCastShadows, uniform int shadowPassCount) : COLOR 
{ 

	float uiConst_nm_1 = 1.0; 
	float uiConst_nm_0 = 0.0; 
	float4 NormalMap = tex2D(NormalMapSampler, In.texCoord.xy);
	NormalMap.xyz = NormalMap.xyz * 2 - 1;		//expand to -1 to 1 range 
	NormalMap.rgb = normalize(NormalMap.rgb); 		//normalized the normal vector 
	float MathIf_586;
	if (invertRed == uiConst_nm_1) MathIf_586 = (uiConst_nm_0 - NormalMap.r); else MathIf_586 = NormalMap.r; 
	float MathIf_7612;
	if (invertGreen == uiConst_nm_1) MathIf_7612 = (uiConst_nm_0 - NormalMap.g); else MathIf_7612 = NormalMap.g; 
	float3 MathVecConstuct_4834 = float3(MathIf_586, MathIf_7612, NormalMap.b);
	float3 MathVecConstuct_5078 = float3(uiConst_nm_1, uiConst_nm_1, (1.0 / nmDepth));
	float3 MathNormalize_8794 = normalize(MathVecConstuct_5078);		//Normalize 
	float3 Normal = float3(0,0,1);	//tangent space normal vector 
	float3 MathIf_3511;
	if (uiConst_nm_1 == useNormalmap) MathIf_3511 = (MathVecConstuct_4834 * MathNormalize_8794); else MathIf_3511 = Normal; 
	float3 MathNormalize_9422 = normalize(MathIf_3511);		//Normalize 
	//this code was added by the World Space Transform Node 
	float3 Nn = normalize(In.worldNormal); 		//input the vectors required for tangent to world space transform 
	float3 Tn = normalize(In.worldTangent); 
	float3 Bn = normalize(In.worldBinormal); 
	#ifdef YUP 
		float3 MathWorldXform_7495 = ( Nn * MathNormalize_9422.z ) + (MathNormalize_9422.x * Tn ) + ( MathNormalize_9422.y * -Bn); 
	#else 
		float3 MathWorldXform_7495 = ( Nn * MathNormalize_9422.z ) + (MathNormalize_9422.x * Bn ) + ( MathNormalize_9422.y * -Tn); 
	#endif 
	float3 MathReflect_3904 = reflect(In.viewDir, MathWorldXform_7495);		//Compute the reflection vector 
	float3 cubeMapInputVector = MathReflect_3904.xyz;
	#ifdef YUP 
	#else 
	cubeMapInputVector.xyz = cubeMapInputVector.xzy;  //swizzle required for Max 
	#endif 
	float4 cubeMap = texCUBE(cubeMapSampler, cubeMapInputVector);
	float4 cubeMapMask = tex2D(cubeMapMaskSampler, In.texCoord.xy);
	float UIConst_dif_is_1 = 1.0; 
	float4 INVertColor_7535 = In.color; 		//bringing in the vertex color 
	float3 UIColor_2605 = float3(1.0f, 1.0f, 1.0f );
	float3 MathIf_9785;
	if (useVertexColours == UIConst_dif_is_1) MathIf_9785 = INVertColor_7535.rgb; else MathIf_9785 = UIColor_2605.rgb; 
	float4 diffuseMap = tex2D(diffuseMapSampler, In.texCoord.xy);
	float3 MathIf_6778;
	if (useDiffuseMap == UIConst_dif_is_1) MathIf_6778 = diffuseMap.rgb; else MathIf_6778 = diffuseColour.rgb; 
	float3 MathOperator_7139 = MathIf_9785 * MathIf_6778;
	float3 MathOperator_1067 = (((cubeMapStrength * cubeMap.rgb) * (1.0 - cubeMapMask.rgb)) * useCubeMap) + (MathOperator_7139 * diffuseToAmbient);
	float UIConst_rim_is_1 = 1.0; 
	float3 rimBlack = float3(0.0f, 0.0f, 0.0f );
	float3 vec_rimOffs = float3(rimOffsX, rimOffsY, rimOffsZ);
	float3 MathIf_rl_2;
	if (UIBool_rim_offsv == UIConst_rim_is_1) MathIf_rl_2 = rimBlack.rgb; else MathIf_rl_2 = vec_rimOffs; 
	float3 V = normalize(In.eyeVec.xyz);		//normalized eye vector 
	float3 MathNormalize_rl_1 = normalize((MathIf_rl_2 + V));		//Normalize 
	float UIConst_rl_is_0 = 0.0; 
	float3 MathIf_rl_1;
	if (disableNMforRim == UIConst_rl_is_0) MathIf_rl_1 = MathNormalize_9422; else MathIf_rl_1 = Normal; 
	float MathDotProduct_rl_1 = saturate(dot(MathNormalize_rl_1,MathIf_rl_1)); 		//clamped dot product 
	float MathPow_rl_1 = pow((rimRange / (0.01 + MathDotProduct_rl_1)),rimContrast);		//x to the power of y 
	float rimMin = 0.0; 
	float rimMax = 1.0; 
	float MathClamp_rl_1 = clamp(MathPow_rl_1, rimMin, rimMax); 
	float3 MathOperator_8286 = (MathClamp_rl_1 * rimColour.rgb) * useRimlight;
	float4 selfiluminationMap = tex2D(selfiluminationMapSampler, In.texCoord.xy);
	float3 MathOperator_6421 = useSelfilum * selfiluminationMap.rgb;
	float3 input1 = (MathOperator_1067 + (MathOperator_8286 + MathOperator_6421)); 
	float uiConst_opm_1 = 1.0; 
	float4 opacityMap = tex2D(opacityMapSampler, In.texCoord.xy);
	float MathIf_3401;
	if (useOpacityMap == uiConst_opm_1) MathIf_3401 = opacityMap.a; else MathIf_3401 = opacityValue; 
	float input3 = MathIf_3401; 

	float4 ret =  float4(input1, 1); 
	ret.a = input3 ; 
	return ret; 
} 

// Vertex Shader: 
v2fT3 vT3(a2vT3 In, uniform float3 lightPos, uniform int lightType, uniform float3 lightDir) 
{ 
	v2fT3 Out = (v2fT3)0; 
	Out.position = mul(In.position, wvp);				//transform vert position to homogeneous clip space 

	In.texCoord += float2(0.0,1.0);		//this fixes Max's V texcoord which is off by one 
	Out.texCoord = In.texCoord;						//pass through texture coordinates from channel 1 
	//this code was added by the World Space Transform Node 
	Out.worldNormal = mul(In.normal, worldIT).xyz;		//compute world space normal 
	Out.worldBinormal = mul(In.binormal, worldIT).xyz;	//compute world space binormal 
	Out.worldTangent = mul(In.tangent, worldIT).xyz;		//compute world space tangent 
	//this code was added by the Vertex Color Node 
	Out.color = float4(In.vertcol.rgb, In.vertalpha.r); 

	//this code was added by the Light Vector Node 
	float3x3 objTangentXf;								//build object to tangent space transform matrix 
	#ifdef YUP 
	objTangentXf[0] = In.tangent.xyz; 
	objTangentXf[1] = -In.binormal.xyz; 
	#else 
	objTangentXf[0] = In.binormal.xyz; 
	objTangentXf[1] = -In.tangent.xyz; 
	#endif 
	objTangentXf[2] = In.normal.xyz; 
	float3 wsLPos = mul(In.position, world).xyz;			//put the vert position in world space 
	float3 wsLVec = lightPos - wsLPos;    //cast a ray to the light 
	float3 osLVec = mul(wsLVec, worldI).xyz;  //transform the world space light vector to object space 
	Out.lightVec = mul(objTangentXf, osLVec);			//tangent space light vector passed out 
	//these three lines were added by the Eye Vector Node 
	float4 osIPos = mul(viewInv[3], worldI);			//put world space eye position in object space 
	float3 osIVec = osIPos.xyz - In.position.xyz;		//object space eye vector 
	Out.eyeVec = mul(objTangentXf, osIVec);				//tangent space eye vector passed out 

	return Out; 
} 

// Pixel Shader: 
float4 fT3(v2fT3 In, uniform float3 lightDir, uniform float4 lightColor, uniform float4 lightAttenuation, uniform float lightHotspot, uniform float lightFalloff, uniform int lightType, uniform int lightattenType, uniform int lightconeType, uniform bool lightCastShadows, uniform int shadowPassCount) : COLOR 
{ 

	float uiConst_nm_1 = 1.0; 
	float uiConst_nm_0 = 0.0; 
	float4 NormalMap = tex2D(NormalMapSampler, In.texCoord.xy);
	NormalMap.xyz = NormalMap.xyz * 2 - 1;		//expand to -1 to 1 range 
	NormalMap.rgb = normalize(NormalMap.rgb); 		//normalized the normal vector 
	float MathIf_586;
	if (invertRed == uiConst_nm_1) MathIf_586 = (uiConst_nm_0 - NormalMap.r); else MathIf_586 = NormalMap.r; 
	float MathIf_7612;
	if (invertGreen == uiConst_nm_1) MathIf_7612 = (uiConst_nm_0 - NormalMap.g); else MathIf_7612 = NormalMap.g; 
	float3 MathVecConstuct_4834 = float3(MathIf_586, MathIf_7612, NormalMap.b);
	float3 MathVecConstuct_5078 = float3(uiConst_nm_1, uiConst_nm_1, (1.0 / nmDepth));
	float3 MathNormalize_8794 = normalize(MathVecConstuct_5078);		//Normalize 
	float3 Normal = float3(0,0,1);	//tangent space normal vector 
	float3 MathIf_3511;
	if (uiConst_nm_1 == useNormalmap) MathIf_3511 = (MathVecConstuct_4834 * MathNormalize_8794); else MathIf_3511 = Normal; 
	float3 MathNormalize_9422 = normalize(MathIf_3511);		//Normalize 
	//this code was added by the World Space Transform Node 
	float3 Nn = normalize(In.worldNormal); 		//input the vectors required for tangent to world space transform 
	float3 Tn = normalize(In.worldTangent); 
	float3 Bn = normalize(In.worldBinormal); 
	#ifdef YUP 
		float3 MathWorldXform_1017 = ( Nn * MathNormalize_9422.z ) + (MathNormalize_9422.x * Tn ) + ( MathNormalize_9422.y * -Bn); 
	#else 
		float3 MathWorldXform_1017 = ( Nn * MathNormalize_9422.z ) + (MathNormalize_9422.x * Bn ) + ( MathNormalize_9422.y * -Tn); 
	#endif 
	float2 CustomCode_8951 = (float2(0.5,0.5) + float2(0.5, -0.5) * float2(normalize(mul(ViewIXf, MathWorldXform_1017).xyz).xy)

);
	float4 LitSphere = tex2D(LitSphereSampler, CustomCode_8951.xy);
	float3 MathOperator_6268 = (LitSphere.rgb * litSphereStrength) * useLitSphere;
	float UIConst_dif_is_1 = 1.0; 
	float4 INVertColor_7535 = In.color; 		//bringing in the vertex color 
	float3 UIColor_2605 = float3(1.0f, 1.0f, 1.0f );
	float3 MathIf_9785;
	if (useVertexColours == UIConst_dif_is_1) MathIf_9785 = INVertColor_7535.rgb; else MathIf_9785 = UIColor_2605.rgb; 
	float4 diffuseMap = tex2D(diffuseMapSampler, In.texCoord.xy);
	float3 MathIf_6778;
	if (useDiffuseMap == UIConst_dif_is_1) MathIf_6778 = diffuseMap.rgb; else MathIf_6778 = diffuseColour.rgb; 
	float3 MathOperator_7139 = MathIf_9785 * MathIf_6778;
	float4 specMap = tex2D(specMapSampler, In.texCoord.xy);
	float3 L = normalize(In.lightVec.xyz);	//normalized light vector 
	float3 V = normalize(In.eyeVec.xyz);		//normalized eye vector 
	float3 NormalizedHalfAngle = normalize((L + V));		//Normalize 
	float NdotH_specular = saturate(dot(NormalizedHalfAngle,MathNormalize_9422)); 		//clamped dot product 
	float UIConst_spec_255 = 255.0; 
	float4 glossMap = tex2D(glossMapSampler, In.texCoord.xy);
	float MathOperator_3845 = (useGlossMap * glossMap.r) + glossBoost;
	float UIConst_spec_debug = 0.04; 
	float NdotH_pow_Glossiness = pow(NdotH_specular,((UIConst_spec_255 * ((MathOperator_3845 * MathOperator_3845) + UIConst_spec_debug)) * glossLevel));		//x to the power of y 
	float3 MathOperator_477 = (((specMap.rgb * useSpecMap) + specBoost) * NdotH_pow_Glossiness) * specLevel;
	float3 MathOperator_2814 = MathOperator_477 * specOverlay;
	float3 input2 = (((MathOperator_6268 * MathOperator_7139) * 1.0) + MathOperator_2814); 
	float uiConst_opm_1 = 1.0; 
	float4 opacityMap = tex2D(opacityMapSampler, In.texCoord.xy);
	float MathIf_3401;
	if (useOpacityMap == uiConst_opm_1) MathIf_3401 = opacityMap.a; else MathIf_3401 = opacityValue; 
	float input3 = MathIf_3401; 

	float4 ret =  float4(input2, 1); 
	ret.a = input3 ; 
	return ret; 
} 

technique ZB  
{  
	pass ambient  
    {		 
		VertexShader = compile vs_3_0 avT3(light1Pos, light1Type, light1Dir); 
		ZEnable = true; 
		ZWriteEnable = true; 
		CullMode = cw; 
		ShadeMode = Gouraud;
		AlphaBlendEnable = true; 
		SrcBlend = SrcAlpha; 
		DestBlend = InvSrcAlpha; 
		AlphaTestEnable = FALSE; 
		PixelShader = compile ps_3_0 afT3(light1Dir, light1Color, light1Attenuation, light1Hotspot, light1Falloff, light1Type, light1attenType, light1coneType, light1CastShadows, 1); 
	}  

	pass light1  
    {		 
		VertexShader = compile vs_3_0 vT3(light1Pos, light1Type, light1Dir); 
		ZEnable = true; 
		CullMode = cw; 
		ShadeMode = Gouraud;
		AlphaBlendEnable = true; 
		ZWriteEnable = true; 
		ZFunc = LessEqual; 
		SrcBlend = SrcAlpha; 
		DestBlend = One; 
		AlphaTestEnable = FALSE; 
		PixelShader = compile ps_3_0 fT3(light1Dir, light1Color, light1Attenuation, light1Hotspot, light1Falloff, light1Type, light1attenType, light1coneType, light1CastShadows, 1); 
	}  

}    